This directory contains regular expressions to help parse Unix related content.

Some of these expressions will only be useful in a Unix/Linux environment, where as others will be useful when dealing with technologies that adhere to Unix/Linux conventions.


|Name                                              |Description                                                |Source                                   |
|--------------------------------------------------|-----------------------------------------------------------|-----------------------------------------|
|[?<Unix_Conf_File>](Conf_File.regex.txt)          |Matches Configuraiton File Content                         |[source](Conf_File.regex.source.ps1)     |
|[?<Unix_Conf_Line>](Conf_Line.regex.txt)          |Matches Lines in a .conf or .ini file.                     |[source](Conf_Line.regex.source.ps1)     |
|[?<Unix_Conf_Section>](Conf_Section.regex.txt)    |Matches Sections in a .conf file.                          |[source](Conf_Section.regex.source.ps1)  |
|[?<Unix_Cron_Interval>](Cron_Interval.regex.txt)  |Matches a Cron interval                                    |[source](Cron_Interval.regex.source.ps1) |
|[?<Unix_Duration>](Duration.regex.txt)            |Matches a Duration, defined in ISO 8601                    |[source](Duration.regex.source.ps1)      |
|[?<Unix_FileSystemType>](FileSystemType.regex.txt)|Matches a File System Type (described in /proc/filesystems)|[source](FileSystemType.regex.source.ps1)|
|[?<Unix_Mount>](Mount.regex.txt)                  |Matches a Unix Mount                                       |[source](Mount.regex.source.ps1)         |
|[?<Unix_User>](User.regex.txt)                    |Matches a User (described in /etc/passwd)                  |[source](User.regex.source.ps1)          |


